/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.mq.il.oil2;

/**
 * MBean interface.
 */
public interface OIL2ServerILServiceMBean extends org.jboss.mq.il.ServerILJMXServiceMBean
{

   /**
    * Getter for property serverBindPort.
    * @return Value of property serverBindPort.
    */
   int getServerBindPort();

   /**
    * Setter for property serverBindPort.
    * @param serverBindPort New value of property serverBindPort.
    */
   void setServerBindPort(int serverBindPort);

   /**
    * Get the interface address the OIL server bind its listening port on.
    * @return The hostname or dotted decimal address that the service is bound to.
    */
   java.lang.String getBindAddress();

   /**
    * Set the interface address the OIL server bind its listening port on.
    * @param host The host address to bind to, if any.
    * @throws java.net.UnknownHostException Thrown if the hostname cannot be resolved to an InetAddress object.
    */
   void setBindAddress(java.lang.String host) throws java.net.UnknownHostException;

   /**
    * Gets the enableTcpNoDelay.
    * @return Returns a boolean
    */
   boolean getEnableTcpNoDelay();

   /**
    * Sets the enableTcpNoDelay.
    * @param enableTcpNoDelay The enableTcpNoDelay to set
    */
   void setEnableTcpNoDelay(boolean enableTcpNoDelay);

   /**
    * Get the javax.net.SocketFactory implementation class to use on the client.
    */
   java.lang.String getClientSocketFactory();

   /**
    * Set the javax.net.SocketFactory implementation class to use on the client.
    */
   void setClientSocketFactory(java.lang.String name);

   /**
    * Set the javax.net.ServerSocketFactory implementation class to use to create the service SocketFactory.
    */
   void setServerSocketFactory(java.lang.String name) throws java.lang.Exception;

   /**
    * Get the javax.net.ServerSocketFactory implementation class to use to create the service SocketFactory.
    */
   java.lang.String getServerSocketFactory();

   /**
    * Set the security domain name to use with SSL aware socket factories
    */
   void setSecurityDomain(java.lang.String domainName);

   /**
    * Get the security domain name to use with SSL aware socket factories
    */
   java.lang.String getSecurityDomain();

}
